﻿Imports System.Net
Imports System.Windows
Imports System.Windows.Controls
Imports System.Windows.Documents
Imports System.Windows.Input
Imports System.Windows.Media
Imports System.Windows.Media.Animation
Imports System.Windows.Shapes

Imports Microsoft.SharePoint.Client

Namespace NonStandBusPurchaseReqsSLOM
    Partial Public Class MainPage
        Inherits UserControl
        Private webUrl As String

        Public Sub New(ByVal url As String)
            webUrl = url

            InitializeComponent()
        End Sub

        Private Sub addNonStanPurchaseReq_Click(ByVal sender As Object, ByVal e As RoutedEventArgs)
            Dim clientContext As New ClientContext(webUrl)

            Dim webSite = clientContext.Web
            Dim webLists = webSite.Lists

            Dim nonStandBusPurList = clientContext.Web.Lists.GetByTitle("Non-Standard Business Purchase Requests")

            Dim newListItem = nonStandBusPurList.AddItem(New ListItemCreationInformation)
            newListItem("Title") = Title.Text
            newListItem("RequestDescription") = Description.Text
            newListItem("Price") = Price.Text

            newListItem.Update()

            clientContext.Load(nonStandBusPurList, Function(list) list.Title)

            clientContext.ExecuteQueryAsync(AddressOf onQuerySucceeded, AddressOf onQueryFailed)
        End Sub

        Private Sub onQuerySucceeded(ByVal sender As Object, ByVal args As ClientRequestSucceededEventArgs)
            Dispatcher.BeginInvoke(Sub() MessageBox.Show("New item added."))
        End Sub

        Private Sub onQueryFailed(ByVal sender As Object, ByVal args As ClientRequestFailedEventArgs)
            Dispatcher.BeginInvoke(Sub() MessageBox.Show("Request failed. " &
                                                         args.Message & vbLf &
                                                         args.StackTrace))
        End Sub
    End Class
End Namespace
